import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.util.ArrayList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyVetoException;
import java.beans.VetoableChangeListener;

public class Applet1
    extends Applet {
  boolean isStandalone = false;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JTextField jTextField1 = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JSlider jSlider1 = new JSlider();
  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
        (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public Applet1() {
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    this.setLayout(null);
    jPanel1.setBackground(Color.white);
    jPanel1.setBounds(new Rectangle(27, 18, 361, 202));
    this.setBackground(SystemColor.textInactiveText);
    jTextField1.setText("50");
    jTextField1.setBounds(new Rectangle(151, 242, 72, 20));
    jTextField1.addKeyListener(new Applet1_jTextField1_keyAdapter(this));
    jLabel1.setText("0");
    jLabel1.setBounds(new Rectangle(17, 220, 34, 15));
    jLabel4.setText("1");
    jLabel4.setBounds(new Rectangle(19, 13, 34, 15));
    jLabel2.setText("100");
    jLabel2.setBounds(new Rectangle(379, 223, 34, 15));
    jLabel3.setText("Signal duration:");
    jLabel3.setBounds(new Rectangle(61, 244, 111, 16));
    jSlider1.setInputVerifier(null);
    jSlider1.setBounds(new Rectangle(70, 262, 151, 14));
    jSlider1.addChangeListener(new Applet1_jSlider1_changeAdapter(this));
    this.add(jPanel1);
    this.add(jLabel1);
    this.add(jLabel4);
    this.add(jLabel2);
    this.add(jTextField1);
    this.add(jSlider1);
    this.add(jLabel3);
  }

  public void paint ( Graphics g )
  {
    super.paint(g);
    stlacenieGombika();
  }
  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }




  public void stlacenieGombika()
  {
    ArrayList signal    =new ArrayList();
    ArrayList aktivacia =new ArrayList();

    double intKrok = 0.5;//integracny krok
    double x[]={0.0,0.0}; //pociatocna aktivacia a jej derivacia

    aktivacia.add(new Double(x[1]));
    double vstup=1.0;
    signal.add(new Double(vstup));

    int krokov=100;
    for(int i=0;i<krokov;i++)
    {

      if( i >= Integer.valueOf(jTextField1.getText()).intValue() )
        vstup=0.0;

      x= krokK0(x,intKrok,vstup);

      signal.add(new Double(vstup));
      aktivacia.add(new Double(x[0]));
    }

    vykreslenie(signal,krokov,0.0,1.0,Color.BLACK,true);
    vykreslenie(aktivacia,krokov,0.0,1.0,Color.RED,false);

  } ///stlacenieGombika

  double[] krokK0(double[] x, double h, double vstup)
  {
    double[] k1 = funkcia(x, vstup);
    k1[0]*=h;k1[1]*=h;

    double[] xpom=new double[2];

    xpom[0]=x[0] + k1[0]/2.0;
    xpom[1]=x[1] + k1[1]/2.0;
    double[] k2 = funkcia(xpom, vstup);
    k2[0]*=h;k2[1]*=h;

    xpom[0]=x[0] + k2[0]/2.0;
    xpom[1]=x[1] + k2[1]/2.0;
    double[] k3 = funkcia(xpom, vstup);
    k3[0]*=h;k3[1]*=h;

    xpom[0]=x[0] + k3[0]/2.0;
    xpom[1]=x[1] + k3[1]/2.0;
    double[] k4 = funkcia(xpom, vstup);
    k4[0]*=h;k4[1]*=h;

    double[] noveX=new double[2];
    noveX[0] = x[0]+(k1[0]+2*(k2[0]+k3[0])+k4[0])/6;
    noveX[1] = x[1]+(k1[1]+2*(k2[1]+k3[1])+k4[1])/6;

    return noveX;
  }

  double[] funkcia(double[] x, double vstup)
  {
    double a=0.22;
    double b=0.72;

    double vystup[]=new double[2];

    vystup[0]=x[1];
    vystup[1]=a*b*vstup - a*b*x[0] - (a+b)*x[1];

    return vystup;
  }

  public void vykreslenie(ArrayList rada, int maxX, double minY, double maxY,
                          Color farba, boolean najprvZmazat)
  {
    Graphics panel=jPanel1.getGraphics();
    int sirka=jPanel1.getWidth();
    int vyska=jPanel1.getHeight();

    maxX--;

    if(najprvZmazat)
    {
      panel.setColor(Color.WHITE);
      panel.fillRect(0, 0, sirka, vyska);
    }

    panel.setColor(farba);
    for(int i=0;i<rada.size()-1;i++)
    {
      double i0=((Double)rada.get(i)).floatValue();
      double i1=((Double)rada.get(i+1)).floatValue();
      panel.drawLine(i * sirka/maxX,
                     vyska  - (int) ( (i0-minY)/(maxY-minY)*vyska ),
                     (i + 1) * sirka/maxX,
                     vyska  - (int) ( (i1-minY)/(maxY-minY)*vyska )
                    );
    }

  }//vykreslenie

  public void jSlider1_stateChanged(ChangeEvent e) {
    int kolko=jSlider1.getValue();
    jTextField1.setText(String.valueOf(kolko));
    stlacenieGombika();
  }

  public void jTextField1_keyReleased(KeyEvent e) {

    if(e.getKeyCode()!=KeyEvent.VK_ENTER) return;

    try {
      Integer.valueOf(jTextField1.getText()).intValue();
      stlacenieGombika();
      jSlider1.setValue( Integer.valueOf(jTextField1.getText()).intValue()  );
    }
    catch (Exception e2) {
    }
  }
}//class applet1


class Applet1_jTextField1_keyAdapter
    extends KeyAdapter {
  private Applet1 adaptee;
  Applet1_jTextField1_keyAdapter(Applet1 adaptee) {
    this.adaptee = adaptee;
  }

  public void keyReleased(KeyEvent e) {
    adaptee.jTextField1_keyReleased(e);
  }
}

class Applet1_jSlider1_changeAdapter
    implements ChangeListener {
  private Applet1 adaptee;
  Applet1_jSlider1_changeAdapter(Applet1 adaptee) {
    this.adaptee = adaptee;
  }

  public void stateChanged(ChangeEvent e) {
    adaptee.jSlider1_stateChanged(e);
  }
}

